Gecode::Search::NoGoodsProp Class Reference

No-good propagator. More...

`#include <nogoods.hh>`

## Public Member Functions

virtual Actor * | copy (Space &home)
| Perform copying during cloning.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Const function (defined as low unary).
virtual void | reschedule (Space &home)
| Schedule function.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

template<class Path>
static ExecStatus | post (Space &home, const Path &p)
| Post propagator for path p.
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| NoGoodsProp (Space &home, NGL *root)
| Constructor for creation.
| NoGoodsProp (Space &home, NoGoodsProp &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

NGL * | root
| Root of no-good literal tree.
unsigned int | n
| Number of no-good literals with subscriptions.

## Detailed Description

No-good propagator.

Definition at line 65 of file nogoods.hh.

## Constructor & Destructor Documentation

## NoGoodsProp() [1/2]

Gecode::Search::NoGoodsProp::NoGoodsProp | ( | Space & | home,
|  | NGL * | root )

inline protected

Constructor for creation.

Definition at line 50 of file nogoods.hpp.

## NoGoodsProp() [2/2]

Gecode::Search::NoGoodsProp::NoGoodsProp | ( | Space & | home,
|  | NoGoodsProp & | p )

inline protected

Constructor for cloning p.

Definition at line 73 of file nogoods.hpp.

## Member Function Documentation

## copy()

Actor * Gecode::Search::NoGoodsProp::copy | ( | Space & | home | ) |

virtual

Perform copying during cloning.

Implements Gecode::Actor.

Definition at line 77 of file nogoods.cpp.

## cost()

PropCost Gecode::Search::NoGoodsProp::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Const function (defined as low unary).

Implements Gecode::Propagator.

Definition at line 82 of file nogoods.cpp.

## reschedule()

void Gecode::Search::NoGoodsProp::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Definition at line 87 of file nogoods.cpp.

## propagate()

ExecStatus Gecode::Search::NoGoodsProp::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 100 of file nogoods.cpp.

## post()

template<class Path>

ExecStatus Gecode::Search::NoGoodsProp::post | ( | Space & | home,
|  | const Path & | p )

inline static

Post propagator for path p.

Definition at line 90 of file nogoods.hpp.

## dispose()

size_t Gecode::Search::NoGoodsProp::dispose | ( | Space & | home | ) |

virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Definition at line 196 of file nogoods.cpp.

## Member Data Documentation

## root

NGL* Gecode::Search::NoGoodsProp::root

protected

Root of no-good literal tree.

Definition at line 68 of file nogoods.hh.

## n

unsigned int Gecode::Search::NoGoodsProp::n

protected

Number of no-good literals with subscriptions.

Definition at line 70 of file nogoods.hh.

The documentation for this class was generated from the following files:

- gecode/search/nogoods.hh
- gecode/search/nogoods.cpp
- gecode/search/nogoods.hpp